Wt examples: JavascriptExample Class Reference

Wt examples 4.10.4

Loading...
Searching...
No Matches
Public Member Functions | Private Member Functions | Private Attributes | List of all members
JavascriptExample Class Reference

An example showing how to interact custom JavaScript with Wt stuff. More...

`#include <JavascriptExample.h>`

Inheritance diagram for JavascriptExample:
[legend]

## Public Member Functions
| JavascriptExample (const WEnvironment &env)
| Create the example application.

## Private Member Functions
void | confirmed ()
| The user has confirmed the payment.
void | setAmount (std::string amount)
| Set the amount to be payed.

## Private Attributes
std::unique_ptr< Popup > | promptAmount_
| Popup for changing the amount.
std::unique_ptr< Popup > | confirmPay_
| Popup for paying.
WText * | currentAmount_
| WText for showing the current amount.

## Detailed Description

An example showing how to interact custom JavaScript with Wt stuff.

Definition at line 24 of file JavascriptExample.h.

## Constructor & Destructor Documentation

## ◆ JavascriptExample()

JavascriptExample::JavascriptExample | ( | const WEnvironment & | env | ) |

Create the example application.

Definition at line 17 of file JavascriptExample.C.

18 : WApplication(env)
19{
20 setTitle("Javascript example");
21
22 // Create a popup for prompting the amount of money, and connect the
23 // okPressed button to the slot for setting the amount of money.
24 //
25 // Note that the input provided by the user in the prompt box is passed as
26 // an argument to the slot.
27 promptAmount_ = Popup::createPrompt("How much do you want to pay?","");
28 promptAmount_->okPressed().connect(std::bind(&JavascriptExample::setAmount,
29 this, std::placeholders::_1));
30
31 // Create a popup for confirming the payment.
32 //
33 // Since a confirm popup does not allow input, we ignore the
34 // argument carrying the input (which will be empty anyway).
35 confirmPay_ = Popup::createConfirm("");
36 confirmPay_->okPressed().connect(this, &JavascriptExample::confirmed);
37
38 root()->addWidget(std::make_unique<WText>("<h2>Wt Javascript example</h2>"
39 "<p>Wt makes abstraction of Javascript, and therefore allows you"
40 " to develop web applications without any knowledge of Javascript,"
41 " and which are not dependent on Javascript."
42 " However, Wt does allow you to add custom Javascript code:</p>"
43 " <ul>"
44 " <li>To call custom JavaScript code from an event handler, "
45 "connect the Wt::EventSignal to a Wt::JSlot.</li>"
46 " <li>To call C++ code from custom JavaScript, use "
47 "Wt.emit() to emit a Wt::JSignal.</li>"
48 " <li>To call custom JavaScript code from C++, use "
49 "WApplication::doJavascript() or Wt::JSlot::exec().</li>"
50 " </ul>"
51 "<p>This simple application shows how to interact between C++ and"
52 " JavaScript using the JSlot and JSignal classes.</p>"));
53
54 currentAmount_
55 = root()->addWidget(std::make_unique<WText>("Current amount: $" +
56 promptAmount_->defaultValue()));
57
58 auto amountButton =
59 root()->addWidget(std::make_unique<WPushButton>("Change ..."));
60 amountButton->setMargin(10, Side::Left | Side::Right);
61
62 root()->addWidget(std::make_unique<WBreak>());
63
64 auto confirmButton =
65 root()->addWidget(std::make_unique<WPushButton>("Pay now."));
66 confirmButton->setMargin(10, Side::Top | Side::Bottom);
67
68 // Connect the event handlers to a JSlot: this will execute the JavaScript
69 // immediately, without a server round trip.
70 amountButton->clicked().connect(promptAmount_->show);
71 confirmButton->clicked().connect(confirmPay_->show);
72
73 // Set the initial amount
74 setAmount("1000");
75}
JavascriptExample::promptAmount_
std::unique_ptr< Popup > promptAmount_
Popup for changing the amount.
Definition JavascriptExample.h:42
JavascriptExample::confirmed
void confirmed()
The user has confirmed the payment.
Definition JavascriptExample.C:89
JavascriptExample::currentAmount_
WText * currentAmount_
WText for showing the current amount.
Definition JavascriptExample.h:50
JavascriptExample::setAmount
void setAmount(std::string amount)
Set the amount to be payed.
Definition JavascriptExample.C:77
JavascriptExample::confirmPay_
std::unique_ptr< Popup > confirmPay_
Popup for paying.
Definition JavascriptExample.h:46
Popup::createConfirm
static std::unique_ptr< Popup > createConfirm(const WString &message)
Create a confirm dialog.
Definition Popup.C:73
Popup::createPrompt
static std::unique_ptr< Popup > createPrompt(const WString &message, const std::string defaultValue)
Create a prompt dialog with the given default value.
Definition Popup.C:83

## Member Function Documentation

## ◆ confirmed()

void JavascriptExample::confirmed | ( |  | ) |
| private

The user has confirmed the payment.

Definition at line 89 of file JavascriptExample.C.

90{
91 root()->addWidget(std::make_unique<WText>("<br/>Just payed $" +
92 promptAmount_->defaultValue() + "."));
93}

## ◆ setAmount()

void JavascriptExample::setAmount | ( | std::string | amount | ) |
| private

Set the amount to be payed.

Definition at line 77 of file JavascriptExample.C.

78{
79 // Change the confirmation message to include the amount.
80 confirmPay_->setMessage("Are you sure you want to pay $" + amount + " ?");
81
82 // Change the default value for the prompt.
83 promptAmount_->setDefaultValue(amount);
84
85 // Change the text that shows the current amount.
86 currentAmount_->setText("Current amount: $" + promptAmount_->defaultValue());
87}

## Member Data Documentation

## ◆ confirmPay_

std::unique_ptr<Popup> JavascriptExample::confirmPay_
| private

Popup for paying.

Definition at line 46 of file JavascriptExample.h.

## ◆ currentAmount_

WText* JavascriptExample::currentAmount_
| private

WText for showing the current amount.

Definition at line 50 of file JavascriptExample.h.

## ◆ promptAmount_

std::unique_ptr<Popup> JavascriptExample::promptAmount_
| private

Popup for changing the amount.

Definition at line 42 of file JavascriptExample.h.

The documentation for this class was generated from the following files:

- javascript/JavascriptExample.h
- javascript/JavascriptExample.C